/* Ultrasound Sensor
 * -----------------
 *
 * Reads values (00014-01199) from an ultrasound sensor (3m sensor)
 * and writes the values to the serialport. The sensor is the
 * so-called PING sensor from Parallax/Devantech.
 *
 * http://www.xlab.se | http://www.0j0.org
 * copyleft 2005 Mackie for XLAB | DojoDave for DojoCorp
 *
 * MODIFIED BY Thomas Ouellet Fredericks
 * You must send a 0 or a 1 to turn off/on serial communication
 * tom@danslchamp.org
 */

int ultraSoundSignal = 8;             // Ultrasound signal pin
int val = 0;
int ultrasoundValue = 0;  
int timecount = 0;                    // Echo counter
int ledPin = 13;                      // LED connected to digital pin 13
char serialdata= 0;
boolean state=0;
int listeningCounter = 0;
int listeningCounterMax = 9999;

void setup() {
  beginSerial(9600);                  // Sets the baud rate to 9600
  pinMode(ledPin, OUTPUT);            // Sets the digital pin as output
}

void loop() {

// Voir s'il faut eteindre ou allumer la communication
if (serialAvailable()) {
    serialdata = serialRead();
  switch (serialdata) {
    case 0: 
      state = 0;
      break;
    case 1:
      state = 1;
      break;
   } // end switch
   digitalWrite(ledPin, state);
} // end if serial





timecount = 0;
val = 0;
pinMode(ultraSoundSignal, OUTPUT);     // Switch signalpin to output

/* Send low-high-low pulse to activate the trigger pulse of the sensor
 * -------------------------------------------------------------------
 */
digitalWrite(ultraSoundSignal, LOW);   // Send low pulse 
delayMicroseconds(2);                            // Wait for 2 microseconds
digitalWrite(ultraSoundSignal, HIGH);  // Send high pulse 
delayMicroseconds(5);                            // Wait for 5 microseconds
digitalWrite(ultraSoundSignal, LOW);   // Holdoff

/* Listening for echo pulse
 * -------------------------------------------------------------------
 */
pinMode(ultraSoundSignal, INPUT);      // Switch signalpin to input
val = digitalRead(ultraSoundSignal);   // Append signal value to val

listeningCounter = 0;
while(val == LOW) {                    // Loop until pin reads a high value
  val = digitalRead(ultraSoundSignal);
  listeningCounter++;
   if (listeningCounter > listeningCounterMax) 
  {
  timecount = listeningCounterMax;
  break;
  }
}

listeningCounter = 0;
while(val == HIGH) {                   // Loop until pin reads a high value
  val = digitalRead(ultraSoundSignal);
  timecount = timecount +1;            // Count echo pulse time
  listeningCounter++;
  if (listeningCounter > listeningCounterMax) 
  {
  break;
  }
}

/* Writing out values to the serial port
 * -------------------------------------------------------------------
 */


ultrasoundValue = timecount;          // Append echo pulse time to ultrasoundValue
if (state==1) {
  serialWrite('u');                     // Example identifier for the sensor
  serialWrite(32);
  printInteger(ultrasoundValue);
  serialWrite(10);
  serialWrite(13);
  delay(5);
} //end if state==1

             
  

}
